;;;
;;;  DIV 2001-Nov-24: 
;;;  LWW System redifinition for easy modification
;;;
;;;  Original Distribution: ftp://amirani.hit.uib.no/sql-odbc/

(in-package :common-lisp-user)

(setf (logical-pathname-translations "sql")
      ;'(("**;*.*" "projects:;sql-odbc-09;**;")))
      `(("**;*.*.*" 
         ;; e.g., "/home/jsc/lisp/src/aserve/aserve-lw/**/"
         ,(merge-pathnames 
           (make-pathname :host (pathname-host *load-truename*)
                          :directory '(:relative :wild-inferiors)
                          :name    :wild
                          :type    :wild
                          :version :wild
                          ;:case :common
                          )
           *load-truename*))))

(push :Russian *features*)

(defsystem :ffc
  (:package :cl-user
   :default-pathname "sql:ffc;lispworks;"
   :object-pathname "sql:bin;"
   :default-type :lisp-file)
  :members ("ffc-package"
            "ff-compatibility-lw")
  :rules ((:in-order-to :compile :all
           (:requires (:load :previous)))))

 ;:finally-do (pushnew :ffc *features*))

(defsystem :sql
  (:package :cl-user
   :default-pathname "sql:sql;"
   :object-pathname "sql:bin;")
  :members ("sql-package"
            "sql-class" 
            "sql-expressions"
            "sql-functional-interface"
            "sql-streams"
            ; "sql-utils"
            #+mcl "sql-fred")
  :rules ((:in-order-to :compile :all
           (:requires (:load :previous)))))
  ;:finally-do (pushnew :sql *features*))

(defsystem :odbc
  (:package :cl-user
   :default-pathname "sql:odbc;"
   :object-pathname "sql:bin;")
  :members ((:ffc :type :system)
            (:sql :type :system)
            "odbc-package" 
            "local"
            "odbc-constants" 
            "odbc-ff-interface"
            "odbc-functions"
            "odbc-sql-interface"
            #-pcl "odbc-streams")
  :rules ((:in-order-to :compile :all
           (:requires (:load :previous)))
          ;(:in-order-to :compile ("odbc-functions")
          ;(:caused-by (:compile "odbc-package"))
          ;(:requires (:load "odbc-package")))
          ))
  ;:finally-do (pushnew :odbc *features*))


