;; this is a rather ad-hoc collection of example commands.
;; they have been tested in MCL 4.2 against Oracle 8.0 on NT

(in-package :sql)

;; customize this
(load-logical-pathname-translations "PROJECTS")  ;; should load translations/project.
(setf (logical-pathname-translations "sql")
      '(("**;*.*" "projects:;sql-odbc-09;**;")))
(setf (logical-pathname-translations "bin")
      '(("**;*.*" "projects:;sql-odbc-09;bin;**;")))

;; sample session

(require :sql "sql:sql;sql-system.lisp")
(require :odbc "sql:odbc;odbc-system.lisp") 

(lw:load-system :odbc) 

;;;(use-package :sql)

;;;(initialize-database-type :odbc)

(setq *trace-sql* t)
(setq odbc::*odbc-driver-connect-p* t)
(enable-sql-reader-syntax)
(disable-sql-reader-syntax)

(data-sources :odbc)
;;(connect "Oracle8PC" :user-id "system" :password "=2)(/)11214((3/%&$/$1#22" :if-exists :warn-old)
(connect "Northwind" :user-id "admin" :password "" :if-exists :warn-old)
(connect "sample" :user-id "admin" :autocommit t :if-exists :warn-old)
(connect "sample35" :autocommit t)
(connect "YCableCompanies")
(connect nil)
(connect "DSN=Sample" :user-id nil :autocommit t :if-exists :warn-old) ; using SQLDriverConnect -  
(disconnect)

(time (execute-query "SELECT Text_,Long_,Single_,Memo_ FROM tab"))
(execute-query "SELECT TOP 5 Text_,DateTime_,Single_,Memo_ FROM tab")
(do-query ((txt b c d m  &rest rest) "SELECT TOP 2 Text_,Byte_,Currency_,DateTime_,Memo_ FROM tab")
  (format t "~&txt=~S:~S b=~S:~S c=~S:~S d=~S m=~S rest=~S" 
    txt (type-of txt) b (type-of b) c (type-of c) (and d (format-time d)) m rest))
;;; LWW:   double-float!
;;;a=640000:FIXNUM b=12.34:SINGLE-FLOAT c=5555.66666d0:DOUBLE-FLOAT rest=NIL
;;;a=536870913:BIGNUM b=43.21:SINGLE-FLOAT c=6666.5555d0:DOUBLE-FLOAT rest=NIL
(do-query ((f1) "SELECT Ole_ FROM tab;")
  (format t "~&1=~S:~S" 
    f1 (type-of f1)))

(do-query ((a b)
           [select [*] :from [tab2]])
          (print (list a b)))

(connect "Test")           ; Jet 3.5 replica
(do-query ((CategoryID CategorName)                ; Test
           [select [CategoryID] [CategoryName] :from [Categories]])
          (print (list CategoryID CategorName)))
(insert-records :into [Categories]
                :attributes '(CategoryName)
                :values '("  "))

(do-query ((CategoryID CategorName)               
           "select CategoryID,CategoryName from Categories;")
   (print (list CategoryID CategorName)))

(defun my-execute-command (sql-string)
  (let ((query (odbc::get-free-query sql:*default-database*)))
    (when *trace-sql*
      (format (if (streamp *trace-sql*) *trace-sql* *trace-output*)
              "~&~A;~%" sql-string))
    (with-slots (odbc::hstmt odbc::database) query
      (unless (eq *active-transactions* t)
        (pushnew database *active-transactions*))
      (with-slots (odbc::henv odbc::hdbc) odbc::database
        (unless odbc::hstmt (setf odbc::hstmt (odbc::%new-statement-handle odbc::hdbc))) 
        (unwind-protect 
            (multiple-value-prog1 
                (odbc::%sql-exec-direct sql-string odbc::hstmt odbc::henv odbc::hdbc)
              (format t "~&columns-count=~A rows-count=~A" 
                (odbc::result-columns-count odbc::hstmt)
                (odbc::result-rows-count odbc::hstmt)))
          (db-close-query query))))))

(defun format-time (&optional universal-time 
                     (date? t)
                     (heure? t)
                     (secondes? t))
   (multiple-value-bind
        (sec min heures date mois annee jour)
       (if universal-time
          (decode-universal-time universal-time)
          (get-decoded-time))
      (declare (ignore jour))
      (let ((date-string "") 
            (heure-string ""))
         (when date?
            (setf date-string
                  (format nil "~2,'0D-~2,'0D-~A" annee mois date)))
                   ;; (format nil "~2,'0D-~2,'0D-~A" date mois annee)))
         (when heure?
            (if secondes?
               (setf heure-string
                     (format nil "~2,'0D:~2,'0D:~2,'0D" heures min sec))
               (setf heure-string
                     (format nil "~2,'0D:~2,'0D" heures min))))
         (concatenate 'string
           date-string
           (if (and date? heure?) ", " "")
           heure-string))))

(execute-command "INSERT INTO tab(Boolean_) VALUES(True)")
(my-execute-command "INSERT INTO tab(DateTime_) VALUES({ts'2001-05-13 13:30:31'})")
(my-execute-command "{CALL testfun}")	;; VB-functions not supported

(do-query ((a b) "SELECT Text_,Text2_ FROM outer_join;")
  (format t "~&a=~S:~S b=~S:~S" 
    a (type-of a) b (type-of b)))
(do-query ((a b) "SELECT {fn CONCAT(tab.Text_,tab.Memo_)}, {fn ABS(tab2.Text2_)} 
 FROM {oj tab LEFT OUTER JOIN tab2 ON tab.id = tab2.ID};")
  (format t "~&a=~S:~S b=~S:~S" 
    a (type-of a) b (type-of b)))

;;; CATALOG Functions
(odbc::db-tables *default-database* "%" nil "%" "VIEW") 
(odbc::db-describe-columns *default-database* "tab" "" "tab" "Text_")
(sql:describe-tables :table-type "TABLE,VIEW")
(sql:describe-columns :table-name "bobbins")

(do-query ((code d_zag) "SELECT ``, `D_zag` FROM Query1;")
  (format t "~&=~S D_zag=~S" 
    code d_zag))

(execute-command "CREATE TABLE ThirdTable2 (FirstName CHAR(10), LastName LONGTEXT);")
(execute-command "CREATE TABLE ThirdTable4 (s short REFERENCES ThirdTable3(s) ON UPDATE CASCADE );")
(execute-command "ALTER TABLE ThirdTable3 ADD l2 integer;")

(execute-command "INSERT INTO Table1(text1,long1) VALUES('  ',33);")

(do-query ((a1 a2) "SELECT a1,a2 FROM Table2")
  (format t "~&1=~S 2=~S" a1 a2))

(select [count [id]] :from [tab2])

(execute-command "INSERT INTO Table1 (text1,long1) SELECT a1,a2 FROM Table2")
(execute-command "UPDATE Table1 SET text1='tetete' WHERE long1=33")

(odbc::%sql-get-info (odbc::hdbc *default-database*) odbc::$SQL_PROCEDURES)
;;;> "Y"

(create-table '|FooTab2|
              '((Id counter :primary-key)
                (Txt (char 32))))

;;; Prepared statements and parameters

(my-execute-command "{CALL tab_update_text(6+5)}")
(do-query ((a b) "{CALL qTabText_ByID(2,2+3)}") 
  (format t "~&a=~S b=~S" a b))

(defparameter *query* (prepare-statement "SELECT * FROM qTabText_ByID"))

(do-bind-query ((a b) *query* 2) 
  (format t "~&a=~S b=~S" a b))

(progn
  (drop-table [foo bazz])
  (create-table [foo bazz] '((text (varchar 200)))))

(execute-command "DELETE * FROM Table2")
(delete-records :from [Table1])

(with-prepared-statement (query [insert :into [Table1] :values '($ $ $)])
  (bind-execute query "" 1001 (get-universal-time)))

(time
 (dotimes (i 1000)
   (with-transaction
     (insert-records :into [Table1]
                     :values (list (format nil "~A" (random 20)) i)))))
; cpu time (non-gc) 22,534 msec user, 17,315 msec system
; cpu time (gc)     520 msec user, 0 msec system
; cpu time (total)  23,054 msec user, 17,315 msec system
; real time  416,408 msec (00:06:56.408)
; space allocation:
;  169,716 cons cells, 674,656 other bytes, 0 static bytes

;; much faster:
(time
 (progn
  (with-prepared-statement (query [insert :into [Table1] :values '($ $ $)])
    (dotimes (i 1000)
      (with-transaction ()
        (bind-execute query (format nil "~A - " (random 20)) 
                      i
                      (+ (get-universal-time) (random 10000))))))))
;8.4 seconds used.
;Standard Allocation 348048 bytes.
;Fixlen Allocation 89595 bytes.
; cpu time (non-gc) 16,665 msec user, 14,191 msec system
; cpu time (gc)     490 msec user, 0 msec system
; cpu time (total)  17,155 msec user, 14,191 msec system
; real time  327,922 msec (00:05:27.922)
; space allocation:
;  152,160 cons cells, 371,568 other bytes, 1602 static bytes

(time (do-query ((txt l d) "SELECT TOP 1000 text1,long1,datetime1 FROM table1")
  (let ((s (format nil "~&txt=~S l=~S d=~S" 
                   txt l (and d (format-time d))))))))
;76.7 seconds used.
;Standard Allocation 702080 bytes.
;Fixlen Allocation 861531 bytes.

(progn
  (ignore-errors (drop-table [foo bizz]))
  (create-table [foo bizz] '((num integer)
                             (text1 (varchar 100))
                             (text2 (varchar 100)))))

(time 
 (with-prepared-command (query [insert :into [foo bizz] :values '($ $ $)])
   (dotimes (i 1000)
     (with-transaction
       (let ((id (random 100)))
         (bind-execute query id (random-string id) (random-string id)))))))

(do-query ((id str1 str2)
           [select [*] :from [foo bizz] :where [like [text1] "%gag%"]])
          (format t "~2d ~a ~a~%" id str1 str2))


(with-prepared-statement (query [select [*] :from [foo bar] 
                                        :where [and [< [id] $] [like [text] $]]])
  (list (bind-execute query 27 "%z%")
        (bind-execute query 24 "%f")))

(defparameter *query*
  (prepare-statement
   [select [ID] [Memo_] :from [tab] :where [and [< [id] $] [like [Text_] $]]]))

(do-bind-query ((&rest args) *query* 10 "%2")
               (print args))

(map-bind-query *query* nil
                (lambda (&rest rest)
                  (print rest))
                100 "%s")

(close-query *query*)



(create-user [foo] :password "bar")
(execute :grant '(connect resource) :to [foo])

 
;(drop-table [foo bar])

(create-table [foo bar]
              '((id integer :primary-key)
                (text (varchar 32))))

(create-table [foo baz]
              '((id integer :primary-key)
                (text (varchar 32))
                (:foreign-key [id] :references [foo bar] [id])))

(create-view [foo bar-baz]
             :replace-p t
             :as [select '([baz id] [bar text] ([baz text] [text1]))
                         :from '([foo bar] [foo baz])
                         :where [= [bar id] [baz id]]])

(with-transaction
  (insert-records :into [foo bar] :values '(17 "jazz")))
(with-transaction
  (insert-records :into [foo baz] :values '(17 "Pacito d'Riveira")))

(select [id] :from [foo bar-baz])

(select [count [id]] :from [foo bar-baz])

(do-query ((a b)
           [select [*] :from [foo bar]])
          (print (list a b)))

(execute-query "select id from foo.bar union select id from foo.bar order by id desc")

(select-union [select id :from [foo bar]]
              [select id :from [foo baz]]
              :order-by '((id desc)))

(let ((schema 'foo))
  (select [id] [text] :from [?schema baz] :order-by '((id desc))))

;; lexicon is a rather huge dictionary database with two tables:

(create-user [lexicon] :password "bar")
(execute :grant '(connect resource) :to [lexicon])

(create-table [lexicon keys]
              '((id integer :primary-key)
                (key (varchar 256) :not-null)
                (category (varchar 32) :not-null)
                (translation (varchar 256))))

(create-table [lexicon examples]
              '((id integer :not-null)
                (example_number integer :not-null)
                (example (varchar 256) :not-null)
                (translation (varchar 256) :not-null)
                (:foreign-key id :references [lexicon keys] (id))))

(select [key] :from [lexicon keys] :where [< rownum 2])

(select [*] :from [lexicon keys] :where [< rownum 2])

(do-query ((a)
           [select [key] :from [lexicon keys] 
                   :where [and [> [length [key]] 20]
                               [< rownum 20]]])
          (print a))

(select '([category] 
          ([count [length [key]] :distinct] [sum]))
        :from [lexicon keys]
        :group-by [category]
        :order-by '(([sum] :desc)))

(select [count [key] :distinct]
        :from [lexicon keys]
        :where [< [rownum] 3])

(select [substr [key] 1 2]
        :from [lexicon keys]
        :where [< [rownum] 8])

(select [key]
        :from [lexicon keys] 
        :where [and [< rownum 200] [< [length [key]] 4]])

(select [category]
        :distinct t
        :from [elhuyar keys] 
        :where [< rownum 200])

(let ((cat 'category)
      (ref-exp [id])
      (operator 'avg))
  (select `(,[?cat] (,[/ [?operator ?ref-exp] 2] ,[?operator]))
          :from [lexicon keys] 
          :where [> [length [key]] 8]
          :group-by [category] 
          :having [> [length [category]] 4]))

(let ((fun 'lpad))
  (select (list [?fun [category] 20 "-+"]
                (list [* [sum [id]] 2] [total]))
          :from [lexicon keys] 
          :where [> [length [key]] 8]
          :group-by [category] 
          :having [> [length [category]] 4]))

(select '([conc [lpad [category] 20 "-+"] "asdf"]
          ([* [sum [id]] 2] [total]))
        :from [lexicon keys] 
        :where [> [length [key]] 8]
        :group-by [category] 
        :having [> [length [category]] 4])

(select-union [select [conc [key] ", Kategorie: " [category]]
                      :from [lexicon keys]
                      :where [< [rownum] 3]]
              [select [conc [category] ", Lemma: " [key]]
                      :from [lexicon keys]
                      :where [< [rownum] 3]]
              :flatp t)


(select [conc [key] ", Kategorie: " [category]]
        :from [lexicon keys]
        :where [<= 3 [id] 9]
        :flatp t)

(select [ceil 3.3] :from [sys dual])
(select [sysdate] :from [sys dual])

(select [keys key] [keys2 key]
        :from '([lexicon keys] ([lexicon keys] [keys2]))
        :where [and [like [keys key]
                          [conc "%" [keys2 key] "%"]]
                    [like [keys2 key] "ehun%"]])

(select [keys key] [example]
        :from '([lexicon keys]
                [select ([example] ([id] [ex-id]))
                        :from [lexicon examples]
                        :where [> [id] 30000]])
        :where [and [= [keys id] [ex-id]]
                    [like [keys key] "hautesk%"]])

(let ((example 'example) (id 'id) (ex-id 'ex-id))
  (declare (ignorable example id ex-id))
  (select [keys key] [example]
          :from `([lexicon keys]
                  ,[select `((,[lpad [?example] 50 "+"] [example])
                             (,[?id] [ex-id]))
                           ;(list [?example] (list [?id] [?ex-id]))
                           :from [lexicon examples]
                           :where [> [id] 30000]])
          :where [and [= [keys id] [ex-id]]
                      [like [keys key] "hautesk%"]]))

(update-records [foo bar]
                :av-pairs '(([id] [+ [id] +13]))
                :attributes '([text])
                :values '([select [text] :from [foo bar]
                                  :where [= [id] 7]])
                :where [> [id] 14])

(update-records [foo bar]
                :av-pairs '(([id] [+ [id] +13])
                            ([text] [select [text] 
                                            :from (([foo bar] [zup]))
                                            :where [= [zup id] [bar id]]
                                            ]))
                :where [> [id] 14])

(defun random-string (size)
  (let ((str (make-string size :element-type 'base-character)))
    (dotimes (i size)
      (setf (char str i) (code-char (+ 97 (random 26)))))
    str))

(values (describe-columns :table-owner "foo" :table-name "bar"))

;; SQL_BINARY

(create-table
 [foo raw-test]
 '((id integer)
   (bar (raw 10))
   (a (varchar 8))))

(insert-records :into [foo raw-test]
                :values (list 1 #*101110010101000011100000000 "raw!"))


;; streams

(do-query ((id (:stream text-stream))
           [select [id] [text] :from [foo bar] :where [< [id] 30]])
          (print id)
          (do ((char (read-char text-stream nil)
                     (read-char text-stream nil))
               (i 0 (1+ i)))
              ((null char))
            (print char)))

(do-query ((id (:stream stream))
           [select [id] [text] :from [foo bar] :where [< [id] 19]])
          (print id)
          (let ((str (make-string 3 :initial-element #\?)))
            (print (peek-char nil stream))
            (print (read-sequence str stream))
            (print str)
            (print (peek-char nil stream))
            (print (peek-char nil stream))
            (print (read-char stream nil))
            (print (read-sequence str stream))
            (print str)
            (print (read-char stream nil))
            ))

(create-table [foo long-test]
              '((id integer :primary-key)
                (text long)))

;; this one might crash in MCL with the DataDirect driver.

(with-prepared-statement (query [insert :into [foo long-test] :values '($ $)])
  (dotimes (i 10)
    (bind-execute-with-stream (query i (:stream stream))
      (dotimes (i 10)
        (write-sequence (random-string 2000) stream)))))
